<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout column align-center justify-center>


        <v-card width="90%">
            <v-card-title>
                <v-layout row class="fab-container">

                    <!--<v-btn-->
                            <!--color="green"-->
                            <!--dark-->
                            <!--small-->
                            <!--absolute-->
                            <!--top-->
                            <!--left-->
                            <!--fab-->
                            <!--@click="add"-->
                    <!--&gt;-->
                        <!--<v-icon light>add</v-icon>-->
                    <!--</v-btn>-->

                </v-layout>
                <v-layout width="100%" align-start justify-center column>
                    <v-layout wrap min-width="100%">
                        <v-text-field @change="setFilterSearch" v-model="filter.search"
                                      label="جست و جو با نام یا شماره تماس"></v-text-field>

                    </v-layout>
                    <v-layout align-start justify-center class="ma-2" row>
                        <v-btn
                                color="green"
                                dark
                                small
                                top
                                center
                                @click="readData"
                        >
                            اعمال فیلتر ها
                        </v-btn>

                        <v-btn
                                color="error"
                                dark
                                small
                                top
                                center
                                @click="removeFilter"
                        >
                            حذف فیلتر ها
                        </v-btn>
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-card class="mt-2" width="90%">
            <v-card-title>
                <v-layout column>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.first_name}}</td>
                            <td>{{ item.last_name}}</td>
                            <td>{{ item.phone_number}}</td>
                            <td>{{ item.plate4 + " " + item.plate3 + " " + item.plate2 + " " + item.plate1}}</td>
                            <td>{{ item.international_plate1 + " " + item.international_plate2 + " " +
                                item.international_plate3 + " " + item.international_plate4}}
                            </td>
                            <td>{{ item.city.name}}</td>
                            <td>{{ item.vehicle.name}}</td>
                            <td>{{ item.cargo_request}}</td>

                            <!--<td class="justify-center layout px-0">-->
                                <!--<v-icon-->
                                        <!--small-->
                                        <!--class="mr-2"-->
                                        <!--@click="edit(item)"-->
                                <!--&gt;-->
                                    <!--edit-->
                                <!--</v-icon>-->

                                <!--<v-icon-->
                                        <!--small-->
                                        <!--@click="deleteItem(item)"-->
                                <!--&gt;-->
                                    <!--delete-->
                                <!--</v-icon>-->
                            <!--</td>-->
                            <!--<td>-->
                                <!--<v-btn small color="error" @click="activateItem(item)">-->
                                    <!--{{ item.status === 0 ? 'فعال سازی' : 'غیرفعال سازی'}}-->
                                <!--</v-btn>-->
                            <!--</td>-->
                            <!--<td>-->
                                <!--<v-btn small color="success" @click="showPhoto(item)">-->
                                    <!--{{'مشاهده عکس'}}-->
                                <!--</v-btn>-->
                            <!--</td>-->
                            <!--<td>-->
                                <!--<v-btn-->
                                        <!--color="error"-->
                                        <!--dark-->
                                        <!--small-->
                                        <!--@click="toggleShow(item.id)"-->
                                <!--&gt;-->
                                    <!--تغییر عکس-->
                                <!--</v-btn>-->
                            <!--</td>-->
                            <!--<td>-->
                                <!--<v-btn-->
                                        <!--color="error"-->
                                        <!--dark-->
                                        <!--small-->
                                        <!--@click="deletePhoto(item)"-->
                                <!--&gt;-->
                                    <!--حذف عکس-->
                                <!--</v-btn>-->
                            <!--</td>-->
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>

                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                        >
                            <v-layout wrap>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setFirstName"
                                                  v-model="selectedItem.first_name"
                                                  label="نام"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setLastName"
                                                  v-model="selectedItem.last_name"
                                                  label="نام خانوادگی"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="phoneRules"
                                                  type="number" @change="setPhoneNumber"
                                                  v-model="selectedItem.phone_number"
                                                  label="شماره تلفن"></v-text-field>
                                </v-flex>
                                <v-spacer>پلاک :</v-spacer>
                                <v-flex class="mt-1" xs12 sm12 md12>
                                    <v-layout row>
                                        <v-text-field :rules="numberRules"
                                                      type="number" v-model="selectedItem.plate4" class="mr-1 ml-1"
                                                      placeholder="22" @change="setPlate1"
                                                      required></v-text-field>
                                        <v-text-field :rules="numberRules"
                                                      type="number" v-model="selectedItem.plate3" class="mr-1 ml-1"
                                                      placeholder="الف" @change="setPlate2"
                                                      required></v-text-field>
                                        <v-text-field :rules="numberRules" v-model="selectedItem.plate2"
                                                      class="mr-1 ml-1" placeholder="253"
                                                      @change="setPlate3"
                                                      required></v-text-field>
                                        <v-text-field :rules="numberRules"
                                                      type="number" v-model="selectedItem.plate1" class="mr-1 ml-1"
                                                      placeholder="11" @change="setPlate4"
                                                      required></v-text-field>
                                    </v-layout>
                                </v-flex>
                                <v-spacer>پلاک بین المللی:</v-spacer>
                                <v-flex class="mt-1" xs12 sm12 md12>
                                    <v-layout row>
                                        <v-text-field :rules="numberRules"
                                                      type="number" v-model="selectedItem.international_plate4"
                                                      class="mr-1 ml-1"
                                                      placeholder="22" @change="setInternationalPlate1"
                                                      required></v-text-field>
                                        <v-text-field :rules="numberRules"
                                                      type="number" v-model="selectedItem.international_plate3"
                                                      class="mr-1 ml-1"
                                                      placeholder="الف" @change="setInternationalPlate2"
                                                      required></v-text-field>
                                        <v-text-field :rules="numberRules" v-model="selectedItem.international_plate2"
                                                      class="mr-1 ml-1"
                                                      placeholder="253" @change="setInternationalPlate3"
                                                      required></v-text-field>
                                        <v-text-field :rules="numberRules"
                                                      type="number" v-model="selectedItem.international_plate1"
                                                      class="mr-1 ml-1"
                                                      placeholder="11" @change="setInternationalPlate4"
                                                      required></v-text-field>
                                    </v-layout>
                                </v-flex>

                                <v-flex xs12 sm4 md4>
                                    <v-select
                                            :rules="nameRules"
                                            v-model="selectedItem.vehicle.name"
                                            :items="vehicle"
                                            item-text="name"
                                            outlined
                                            label="ماشین مورد نظر را انتخاب کنید"
                                            single-line
                                            @change="setVehicle"
                                            return-object
                                    ></v-select>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field
                                            :rules="nameRules" readonly v-model="selectedItem.city.name"
                                            label="شهر"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-btn small class="mr-2" color="error" @click="showSelectCity">
                                        انتخاب شهر
                                    </v-btn>
                                </v-flex>
                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این راننده را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="WaitDialog"
                dark
                persistent
                width="300"
        >
            <v-card
                    color="primary"
                    dark
            >
                <v-card-text>
                    لطفا منتظر بمانید
                    <v-progress-linear
                            indeterminate
                            color="white"
                            class="mb-0"
                    ></v-progress-linear>
                </v-card-text>
            </v-card>
        </v-dialog>
        <v-dialog v-model="selectCity" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                        v-model="selectedProvince"
                                        :items="province"
                                        item-text="name"
                                        outlined
                                        label="استان را انتخاب کنید"
                                        single-line
                                        @change="getCity"
                                        return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                        v-show="this.cityPending === false"
                                        v-model="selectedCity"
                                        :items="city"
                                        item-text="name"
                                        outlined
                                        label="شهر را انتخاب کنید"
                                        single-line
                                        @change="setSelectedCity"
                                        return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideSelectCity">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="saveSelectedItemCity">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="photoDialog"
                max-width="90%"
        >
            <v-card
                    white
            >
                <v-card-text>
                    <v-layout align-center justify-center>
                        <img :src="selectedItem.photo_url">
                    </v-layout>
                </v-card-text>


                <v-card-actions>
                    <v-btn color="blue darken-1" flat @click="hidePhotoDialog">بستن</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <my-upload field="img"
                   @crop-success="cropSuccess"
                   @crop-upload-success="cropUploadSuccess"
                   @crop-upload-fail="cropUploadFail"
                   v-model="show"
                   :width="300"
                   :height="300"
                   url="/api/v1/panel/update-marketerDriver-profile-photo"
                   :params="params"
                   :headers="header"
                   langType="en"
                   img-format="png"></my-upload>

    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";
    import {getToken} from "../../../data/localStorage"
    import myUpload from 'vue-image-crop-upload';
    import Vue from 'vue';

    export default {
        name: "marketerDriver",
        methods: {
            ...mapMutations({
                setFirstName: 'marketerDriver/setFirstName',
                setLastName: 'marketerDriver/setLastName',
                setPostalCode: 'marketerDriver/setPostalCode',
                setAddress: 'marketerDriver/setAddress',
                setPhoneNumber: 'marketerDriver/setPhoneNumber',
                setEmail: 'marketerDriver/setEmail',
                setPlate1: 'marketerDriver/setPlate1',
                setPlate2: 'marketerDriver/setPlate2',
                setPlate3: 'marketerDriver/setPlate3',
                setPlate4: 'marketerDriver/setPlate4',
                setInternationalPlate1: 'marketerDriver/setInternationalPlate1',
                setInternationalPlate2: 'marketerDriver/setInternationalPlate2',
                setInternationalPlate3: 'marketerDriver/setInternationalPlate3',
                setInternationalPlate4: 'marketerDriver/setInternationalPlate4',
                setVehicle: 'marketerDriver/setVehicle',
                setSelectedItem: 'marketerDriver/setSelectedItem',
                showAddDialog: 'marketerDriver/showAddDialog',
                hideAddDialog: 'marketerDriver/hideAddDialog',
                showDeleteDialog: 'marketerDriver/showDeleteDialog',
                hideDeleteDialog: 'marketerDriver/hideDeleteDialog',
                showSelectCity: 'marketerDriver/showSelectCity',
                hideSelectCity: 'marketerDriver/hideSelectCity',
                showCityPending: 'marketerDriver/showCityPending',
                hideCityPending: 'marketerDriver/hideCityPending',
                setProvince: 'marketerDriver/setProvince',
                setCity: 'marketerDriver/setCity',
                setSelectedProvince: 'marketerDriver/setSelectedProvince',
                setSelectedCity: 'marketerDriver/setSelectedCity',
                setSelectedItemCity: 'marketerDriver/setSelectedItemCity',
                setFilterSearch: 'marketerDriver/setFilterSearch',
                showPhotoDialog: 'marketerDriver/showPhotoDialog',
                hidePhotoDialog: 'marketerDriver/hidePhotoDialog',

            }),
            ...mapActions({
                removePhoto: 'marketerDriver/removePhoto',
                removeFilter: 'marketerDriver/removeFilter',
                readData: 'marketerDriver/readData',
                addOrEdit: 'marketerDriver/addOrEdit',
                deleteOne: 'marketerDriver/deleteOne',
                activate: 'marketerDriver/activate',
                getCityByProvince: 'marketerDriver/getCityByProvince'
            }),
            add() {
                this.setSelectedItem({
                    id: null,
                    first_name: null,
                    last_name: null,
                    phone_number: null,
                    status: null,
                    credit: null,
                    point: null,
                    plate1: null,
                    plate2: null,
                    plate3: null,
                    plate4: null,
                    photo_url: null,
                    international_plate1: null,
                    international_plate2: null,
                    international_plate3: null,
                    international_plate4: null,
                    is_aboard_eager: null,
                    marketer_id: null,
                    city_id: null,
                    vehicle_id: null,
                    vehicle: {id: null, name: null, max_capacity: null, vehicle_group_id: null},
                    city: {id: null, name: null}
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    first_name: item.first_name,
                    last_name: item.last_name,
                    phone_number: item.phone_number,
                    status: item.status,
                    credit: item.credit,
                    point: item.point,
                    plate1: item.plate1,
                    plate2: item.plate2,
                    plate3: item.plate3,
                    plate4: item.plate4,
                    international_plate1: item.international_plate1,
                    international_plate2: item.international_plate2,
                    international_plate3: item.international_plate3,
                    international_plate4: item.international_plate4,
                    photo_url: item.photo_url,
                    is_aboard_eager: item.is_aboard_eager,
                    marketer_id: item.marketer_id,
                    city_id: item.city_id,
                    vehicle_id: item.vehicle_id,
                    vehicle: item.vehicle,
                    city: item.city
                });
                this.showAddDialog();
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },
            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
            activateItem(item) {
                this.setSelectedItem(item);
                this.activate(item)
            },
            getCity(item) {
                console.log('item', item);
                this.setSelectedProvince(item);
                this.getCityByProvince();
            },
            saveSelectedItemCity() {
                this.setSelectedItemCity();
                this.hideSelectCity()
            },
            showPhoto(item) {
                if (item.photo_url === null){
                    alert("راننده عکس ندارد");
                    return;
                }
                this.setSelectedItem(item);
                this.showPhotoDialog();
            },
            deletePhoto(item) {
                this.setSelectedItem(item);
                this.removePhoto();
            },
            toggleShow(id) {
                this.params.id = id;
                this.show = !this.show;
            },
            /**
             * crop success
             *
             * [param] imgDataUrl
             * [param] field
             */
            cropSuccess(imgDataUrl, field){
                console.log('-------- crop success --------');
                this.imgDataUrl = imgDataUrl;
            },
            /**
             * upload success
             *
             * [param] jsonData  server api return data, already json encode
             * [param] field
             */
            cropUploadSuccess(jsonData, field){
                console.log('-------- upload success --------');
                console.log(jsonData);
                console.log('field: ' + field);
            },
            /**
             * upload fail
             *
             * [param] status    server api return error status, like 500
             * [param] field
             */
            cropUploadFail(status, field){
                console.log('-------- upload fail --------');
                console.log(status);
                console.log('field: ' + field);
            }
        },
        computed: {

            ...mapState({
                allData: state => state.marketerDriver.allData,
                AddDialog: state => state.marketerDriver.AddDialog,
                DeleteDialog: state => state.marketerDriver.DeleteDialog,
                selectedItem: state => state.marketerDriver.selectedItem,
                pending: state => state.marketerDriver.pending,
                allDataLoading: state => state.marketerDriver.allDataLoading,
                WaitDialog: state => state.marketerDriver.WaitDialog,
                selectCity: state => state.marketerDriver.selectCity,
                province: state => state.marketerDriver.province,
                city: state => state.marketerDriver.city,
                selectedProvince: state => state.marketerDriver.selectedProvince,
                selectedCity: state => state.marketerDriver.selectedCity,
                cityPending: state => state.marketerDriver.cityPending,
                vehicle: state => state.marketerDriver.vehicle,
                filter: state => state.marketerDriver.filter,
                photoDialog: state => state.marketerDriver.photoDialog,
                imageData: state => state.marketerDriver.imageData,
            }),
            selectedProvince: {
                set: function (value) {

                },
                get: function () {

                }
            },
            selectedCity: {
                set: function (value) {

                },
                get: function () {

                }
            },
            imageData: {
                set: function (value) {

                },
                get: function () {

                }
            }
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                    v => (!v || v.length >= 2) || 'حداقل باید 4 کاراکتر بنویسید',
                ],
                numberRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                phoneRules: [
                    v => !!v || 'شماره موبایل لازم است',
                    v => (!v || v.length === 11) || 'شماره موبایل لازم است 11 رقم باشد',
                ],
                headers: [
                    {text: 'نام', align: 'right', value: 'first_name'},
                    {text: 'نام خانوادگی', align: 'right', value: 'last_name'},
                    {text: 'شماره تلفن', align: 'right', value: 'phone_number'},
                    {text: 'پلاک', align: 'right', value: 'plate1'},
                    {text: 'پلاک بین المللی', align: 'right', value: 'international_plate1'},
                    {text: 'شهر', align: 'right', value: 'city.name'},
                    {text: 'ماشین', align: 'right', value: 'vehicle.name'},
                    {text: 'تعداد درخواست ها', align: 'right', value: 'cargo_request'},

                ],
                show: false,
                params: {
                    id: 'avatar'
                },
                header:{
                    Authorization: getToken(),
                },
                imgDataUrl: ''
            }
        },
        components: {
            'my-upload': myUpload
        },
    }
</script>
<style scoped>
    .layout {
        min-width: 100%;
    }
</style>